Repos / hi.imnhan.com / b0657927bb
commit b0657927bbf9b9c4c5bc34cef5c4f4038b751ed0
Author: nhanb <nhan@nerdyweekly.com>
Date:   Sat Aug 2 16:35:24 2014 +0700

    use latest util files
    
    Makefile, develop_server.sh and fabfile.py copied from pelican 3.4's
    quickstart

diff --git a/Makefile b/Makefile
index 0ad7a53..3086dc3 100644
--- a/Makefile
+++ b/Makefile
@@ -1,5 +1,5 @@
-PY=python
-PELICAN=pelican
+PY?=python3
+PELICAN?=pelican
 PELICANOPTS=
 
 BASEDIR=$(CURDIR)
@@ -12,15 +12,26 @@ FTP_HOST=localhost
 FTP_USER=anonymous
 FTP_TARGET_DIR=/
 
-SSH_HOST=github.com
+SSH_HOST=localhost
 SSH_PORT=22
-SSH_USER=git
-SSH_TARGET_DIR=nhanb/blog.git
+SSH_USER=root
+SSH_TARGET_DIR=/var/www
 
 S3_BUCKET=my_s3_bucket
 
+CLOUDFILES_USERNAME=my_rackspace_username
+CLOUDFILES_API_KEY=my_rackspace_api_key
+CLOUDFILES_CONTAINER=my_cloudfiles_container
+
 DROPBOX_DIR=~/Dropbox/Public/
 
+GITHUB_PAGES_BRANCH=master
+
+DEBUG ?= 0
+ifeq ($(DEBUG), 1)
+	PELICANOPTS += -D
+endif
+
 help:
 	@echo 'Makefile for a pelican Web site                                        '
 	@echo '                                                                       '
@@ -29,34 +40,42 @@ help:
 	@echo '   make clean                       remove the generated files         '
 	@echo '   make regenerate                  regenerate files upon modification '
 	@echo '   make publish                     generate using production settings '
-	@echo '   make serve                       serve site at http://localhost:8000'
-	@echo '   make devserver                   start/restart develop_server.sh    '
+	@echo '   make serve [PORT=8000]           serve site at http://localhost:8000'
+	@echo '   make devserver [PORT=8000]       start/restart develop_server.sh    '
 	@echo '   make stopserver                  stop local server                  '
-	@echo '   ssh_upload                       upload the web site via SSH        '
-	@echo '   rsync_upload                     upload the web site via rsync+ssh  '
-	@echo '   dropbox_upload                   upload the web site via Dropbox    '
-	@echo '   ftp_upload                       upload the web site via FTP        '
-	@echo '   s3_upload                        upload the web site via S3         '
-	@echo '   github                           upload the web site via gh-pages   '
+	@echo '   make ssh_upload                  upload the web site via SSH        '
+	@echo '   make rsync_upload                upload the web site via rsync+ssh  '
+	@echo '   make dropbox_upload              upload the web site via Dropbox    '
+	@echo '   make ftp_upload                  upload the web site via FTP        '
+	@echo '   make s3_upload                   upload the web site via S3         '
+	@echo '   make cf_upload                   upload the web site via Cloud Files'
+	@echo '   make github                      upload the web site via gh-pages   '
+	@echo '                                                                       '
+	@echo 'Set the DEBUG variable to 1 to enable debugging, e.g. make DEBUG=1 html'
 	@echo '                                                                       '
 
-
-html: clean $(OUTPUTDIR)/index.html
-
-$(OUTPUTDIR)/%.html:
+html:
 	$(PELICAN) $(INPUTDIR) -o $(OUTPUTDIR) -s $(CONFFILE) $(PELICANOPTS)
 
 clean:
-	[ ! -d $(OUTPUTDIR) ] || find $(OUTPUTDIR) -mindepth 1 -delete
+	[ ! -d $(OUTPUTDIR) ] || rm -rf $(OUTPUTDIR)
 
-regenerate: clean
+regenerate:
 	$(PELICAN) -r $(INPUTDIR) -o $(OUTPUTDIR) -s $(CONFFILE) $(PELICANOPTS)
 
 serve:
+ifdef PORT
+	cd $(OUTPUTDIR) && $(PY) -m pelican.server $(PORT)
+else
 	cd $(OUTPUTDIR) && $(PY) -m pelican.server
+endif
 
 devserver:
+ifdef PORT
+	$(BASEDIR)/develop_server.sh restart $(PORT)
+else
 	$(BASEDIR)/develop_server.sh restart
+endif
 
 stopserver:
 	kill -9 `cat pelican.pid`
@@ -70,7 +89,7 @@ ssh_upload: publish
 	scp -P $(SSH_PORT) -r $(OUTPUTDIR)/* $(SSH_USER)@$(SSH_HOST):$(SSH_TARGET_DIR)
 
 rsync_upload: publish
-	rsync -e "ssh -p $(SSH_PORT)" -P -rvz --delete $(OUTPUTDIR)/ $(SSH_USER)@$(SSH_HOST):$(SSH_TARGET_DIR) --cvs-exclude
+	rsync -e "ssh -p $(SSH_PORT)" -P -rvzc --delete $(OUTPUTDIR)/ $(SSH_USER)@$(SSH_HOST):$(SSH_TARGET_DIR) --cvs-exclude
 
 dropbox_upload: publish
 	cp -r $(OUTPUTDIR)/* $(DROPBOX_DIR)
@@ -79,61 +98,13 @@ ftp_upload: publish
 	lftp ftp://$(FTP_USER)@$(FTP_HOST) -e "mirror -R $(OUTPUTDIR) $(FTP_TARGET_DIR) ; quit"
 
 s3_upload: publish
-	s3cmd sync $(OUTPUTDIR)/ s3://$(S3_BUCKET) --acl-public --delete-removed
+        s3cmd sync $(OUTPUTDIR)/ s3://$(S3_BUCKET) --acl-public --delete-removed --guess-mime-type
+
+cf_upload: publish
+	cd $(OUTPUTDIR) && swift -v -A https://auth.api.rackspacecloud.com/v1.0 -U $(CLOUDFILES_USERNAME) -K $(CLOUDFILES_API_KEY) upload -c $(CLOUDFILES_CONTAINER) .
 
 github: publish
 	ghp-import $(OUTPUTDIR)
 	git push git@github.com:nhanb/nhanb.github.io.git gh-pages:master
 
-.PHONY: html help clean regenerate serve devserver publish ssh_upload rsync_upload dropbox_upload ftp_upload s3_upload github
-
-
-######################################################################
-# post/page operations
-######################################################################
-
-PAGESDIR=$(INPUTDIR)/pages
-DATE := $(shell date +'%Y-%m-%d %H:%M:%S')
-SLUG := $(shell echo '${NAME}' | sed -e 's/[^[:alnum:]]/-/g' | tr -s '-' | tr A-Z a-z)
-EXT ?= md
-
-newpost:
-ifdef NAME
-	echo "Title: $(NAME)" >  $(INPUTDIR)/$(SLUG).$(EXT)
-	echo "Slug: $(SLUG)" >> $(INPUTDIR)/$(SLUG).$(EXT)
-	echo "Date: $(DATE)" >> $(INPUTDIR)/$(SLUG).$(EXT)
-	echo ""              >> $(INPUTDIR)/$(SLUG).$(EXT)
-	echo ""              >> $(INPUTDIR)/$(SLUG).$(EXT)
-	${EDITOR} ${INPUTDIR}/${SLUG}.${EXT} &
-else
-	@echo 'Variable NAME is not defined.'
-	@echo 'Do make newpost NAME='"'"'Post Name'"'"
-endif
-
-editpost:
-ifdef NAME
-	${EDITOR} ${INPUTDIR}/${SLUG}.${EXT} &
-else
-	@echo 'Variable NAME is not defined.'
-	@echo 'Do make editpost NAME='"'"'Post Name'"'"
-endif
-
-newpage:
-ifdef NAME
-	echo "Title: $(NAME)" >  $(PAGESDIR)/$(SLUG).$(EXT)
-	echo "Slug: $(SLUG)" >> $(PAGESDIR)/$(SLUG).$(EXT)
-	echo ""              >> $(PAGESDIR)/$(SLUG).$(EXT)
-	echo ""              >> $(PAGESDIR)/$(SLUG).$(EXT)
-	${EDITOR} ${PAGESDIR}/${SLUG}.$(EXT)
-else
-	@echo 'Variable NAME is not defined.'
-	@echo 'Do make newpage NAME='"'"'Page Name'"'"
-endif
-
-editpage:
-ifdef NAME
-	${EDITOR} ${PAGESDIR}/${SLUG}.$(EXT)
-else
-	@echo 'Variable NAME is not defined.'
-	@echo 'Do make editpage NAME='"'"'Page Name'"'"
-endif
+.PHONY: html help clean regenerate serve devserver publish ssh_upload rsync_upload dropbox_upload ftp_upload s3_upload cf_upload github
diff --git a/develop_server.sh b/develop_server.sh
index 0909d7b..e295a8d 100755
--- a/develop_server.sh
+++ b/develop_server.sh
@@ -2,8 +2,8 @@
 ##
 # This section should match your Makefile
 ##
-PY=python
-PELICAN=pelican
+PY=${PY:-python3}
+PELICAN=${PELICAN:-pelican}
 PELICANOPTS=
 
 BASEDIR=$(pwd)
@@ -19,11 +19,11 @@ SRV_PID=$BASEDIR/srv.pid
 PELICAN_PID=$BASEDIR/pelican.pid
 
 function usage(){
-  echo "usage: $0 (stop) (start) (restart)"
-  echo "This starts pelican in debug and reload mode and then launches"
-  echo "A pelican.server to help site development. It doesn't read"
-  echo "your pelican options so you edit any paths in your Makefile"
-  echo "you will need to edit it as well"
+  echo "usage: $0 (stop) (start) (restart) [port]"
+  echo "This starts Pelican in debug and reload mode and then launches"
+  echo "an HTTP server to help site development. It doesn't read"
+  echo "your Pelican settings, so if you edit any paths in your Makefile"
+  echo "you will need to edit your settings as well."
   exit 3
 }
 
@@ -35,14 +35,14 @@ function shut_down(){
   PID=$(cat $SRV_PID)
   if [[ $? -eq 0 ]]; then
     if alive $PID; then
-      echo "Killing pelican.server"
+      echo "Stopping HTTP server"
       kill $PID
     else
       echo "Stale PID, deleting"
     fi
     rm $SRV_PID
   else
-    echo "pelican.server PIDFile not found"
+    echo "HTTP server PIDFile not found"
   fi
 
   PID=$(cat $PELICAN_PID)
@@ -60,38 +60,42 @@ function shut_down(){
 }
 
 function start_up(){
-  echo "Starting up Pelican and pelican.server"
+  local port=$1
+  echo "Starting up Pelican and HTTP server"
   shift
   $PELICAN --debug --autoreload -r $INPUTDIR -o $OUTPUTDIR -s $CONFFILE $PELICANOPTS &
   pelican_pid=$!
   echo $pelican_pid > $PELICAN_PID
   cd $OUTPUTDIR
-  $PY -m pelican.server &
+  $PY -m pelican.server $port &
   srv_pid=$!
   echo $srv_pid > $SRV_PID
   cd $BASEDIR
   sleep 1
   if ! alive $pelican_pid ; then
-    echo "Pelican didn't start. Is the pelican package installed?"
+    echo "Pelican didn't start. Is the Pelican package installed?"
     return 1
   elif ! alive $srv_pid ; then
-    echo "pelican.server didn't start. Is the pelican package installed?"
+    echo "The HTTP server didn't start. Is there another service using port 8000?"
     return 1
   fi
-  echo 'Pelican and pelican.server processes now running in background.'
+  echo 'Pelican and HTTP server processes now running in background.'
 }
 
 ###
 #  MAIN
 ###
-[[ $# -ne 1 ]] && usage
+[[ ($# -eq 0) || ($# -gt 2) ]] && usage
+port=''
+[[ $# -eq 2 ]] && port=$2
+
 if [[ $1 == "stop" ]]; then
   shut_down
 elif [[ $1 == "restart" ]]; then
   shut_down
-  start_up
+  start_up $port
 elif [[ $1 == "start" ]]; then
-  if ! start_up; then
+  if ! start_up $port; then
     shut_down
   fi
 else
diff --git a/fabfile.py b/fabfile.py
new file mode 100644
index 0000000..39dd7aa
--- /dev/null
+++ b/fabfile.py
@@ -0,0 +1,73 @@
+from fabric.api import *
+import fabric.contrib.project as project
+import os
+import sys
+import SimpleHTTPServer
+import SocketServer
+
+# Local path configuration (can be absolute or relative to fabfile)
+env.deploy_path = 'output'
+DEPLOY_PATH = env.deploy_path
+
+# Remote server configuration
+production = 'root@localhost:22'
+dest_path = '/var/www'
+
+# Rackspace Cloud Files configuration settings
+env.cloudfiles_username = 'my_rackspace_username'
+env.cloudfiles_api_key = 'my_rackspace_api_key'
+env.cloudfiles_container = 'my_cloudfiles_container'
+
+
+def clean():
+    if os.path.isdir(DEPLOY_PATH):
+        local('rm -rf {deploy_path}'.format(**env))
+        local('mkdir {deploy_path}'.format(**env))
+
+def build():
+    local('pelican -s pelicanconf.py')
+
+def rebuild():
+    clean()
+    build()
+
+def regenerate():
+    local('pelican -r -s pelicanconf.py')
+
+def serve():
+    os.chdir(env.deploy_path)
+
+    PORT = 8000
+    class AddressReuseTCPServer(SocketServer.TCPServer):
+        allow_reuse_address = True
+
+    server = AddressReuseTCPServer(('', PORT), SimpleHTTPServer.SimpleHTTPRequestHandler)
+
+    sys.stderr.write('Serving on port {0} ...\n'.format(PORT))
+    server.serve_forever()
+
+def reserve():
+    build()
+    serve()
+
+def preview():
+    local('pelican -s publishconf.py')
+
+def cf_upload():
+    rebuild()
+    local('cd {deploy_path} && '
+          'swift -v -A https://auth.api.rackspacecloud.com/v1.0 '
+          '-U {cloudfiles_username} '
+          '-K {cloudfiles_api_key} '
+          'upload -c {cloudfiles_container} .'.format(**env))
+
+@hosts(production)
+def publish():
+    local('pelican -s publishconf.py')
+    project.rsync_project(
+        remote_dir=dest_path,
+        exclude=".DS_Store",
+        local_dir=DEPLOY_PATH.rstrip('/') + '/',
+        delete=True,
+        extra_opts='-c',
+    )